// CLRMAME Fixfile Generator
// Programmed by Pugsy on 05 May 2002
// Beware it will overwrite .dat files in the same directory without warning (not a problem as the .exe  should reside in the logs folder)

#include <stdio.h>
#include <string.h>

void Instructions (char *ProgramName)
{
	printf("## FIXGEN V1.0 - CLRMAME Pro DAT Fix Generator                               ##\n");
	printf("## Programmed by Pugsy on 05 May 2002 (email : pugsy@gmx.net)                ##\n");
	printf("## This program will take a CLRMAME Pro logfile and from it create a dat     ##\n");
	printf("## file that a third person can use with CLRMAME Pro to generate a zip file  ##\n");
	printf("## containing all the files (roms etc) that they have but you have not got.  ##\n");
	printf("## This makes it easy to swap ROMs without manually finding, unzipping and   ##\n");
	printf("## rezipping the ones the other person requires. Just send the produced .dat ##\n");
	printf("## file called 'nickname'.dat to them. Then when they feed it in to CLRMAME  ##\n");
	printf("## Pro and they use the CLRMAME Pro Rebuilder function it will make a big    ##\n");
        printf("## zip called 'nickname'fix.zip when fed with the appropriate ROM dirs. More ##\n");
	printf("## information about how to use the CLRMAME Pro Rebuilder can be found in    ##\n");
	printf("## the CLRMAME docs - ensure the person rebuilding acquaints themselves with ##\n");
	printf("## them! I recommend you copy the Fixgen.exe to the CLRMAME Pro logs folder  ##\n");
	printf("## and run it from there! For the person doing the rebuilding I suggest you  ##\n");
	printf("## ensure that the 'Remove Rebuilt Sourcefiles' checkbox in the Rebuilder    ##\n");
	printf("## dialogue is UNTICKED as you don't want to delete your own ROMs!           ##\n");
	printf("##                                                                           ##\n");
	printf("## This program (and source) is completely free of charge and it is provided ##\n");
	printf("## without any warranty. USE IT AT YOUR OWN RISK!!!                          ##\n");
	printf("##                                                                           ##\n");
	printf("## For the moment this tool will remain as a commandline only.  Just copy    ##\n");
	printf("## the FIXGEN executable to the CLRMAME logs folder and run it from there!   ##\n");
	printf("##                                                                           ##\n");
	printf("## Commandline : FixGen [Saved CLRMAME Logfile] [Your Nickname]              ##\n");
	printf("## Example : Fixgen MAME060.log Pugsy                                        ##\n");
}

int main (int argc, char **argv)
{
	char InputLogFilename [255] = "";	// The filename of the log file you want to create a fix .dat for
	FILE *FI;				// The file for the above
	char OutputDatFilename [255] = "";	// The filename of the output dat file - this will be generated from the NickName with a .dat on the end
	FILE *FO;				// The file for the above
	char NickName [251] = "";		// The nickname of the person who wants the fix zip file
	char *pointer;				// A pointer we use when we read the log file
	char CLRMAMEDatLine [255];              // Allows 255 characters per log file line - should be plenty.
	int  ROMNumber = 0;			// Lets keep a count shall we!
	int i;					// Used for loop control

	struct DatStructure
	{					// All variables will be char type because we are treating them as text only
		char ROMname [1024]; 		// Holds the name of the ROM from the logfile (we will alter it to make it unique with crc later)
		char ROMsize [12];		// As long as the ROMsize is under 1000 Gb we will be ok...
		char ROMcrc [8];		// The CRC32 of the file
	} CLRMAMEDat;

	if (2 <= argc)					// Let's get the first arguement from the commandline if it exists - the donor log file's name.
		strcpy(InputLogFilename, argv[1]);	// And store it in the InputLogFilename

	if (3 <= argc)					// Let's get the second arguement from the commandline if it exists - the nickname of the person requiring the files.
	{
		strcpy(OutputDatFilename, argv[2]);
		strcat(OutputDatFilename,".dat");			//Add the .dat extension to the output dat file
		strcpy(NickName, argv[2]);
		for (i = 0; i < strlen(NickName); i ++)
			NickName[i] = (unsigned char)tolower(NickName[i]);
	}

	if ((!InputLogFilename[0]) || (!NickName[0]))    //Not enough arguements have been passed from the commandline - extra arguements will be ignored
	{
		Instructions(argv[0]);					//Print out the brief instuctions on how to use the program
		return(1);
	}

	if (!stricmp(InputLogFilename, OutputDatFilename))		//Check for identical input and output filenames
	{								//No problem as long as the log file has got a log extension
		printf("\nSorry, the input and output files must have different names!\n\n");
		return(2);
	}

	FI = fopen(InputLogFilename,"r");    				// Open Log File for reading - log file is perfectly safe

	if (!FI)							// Check to see if donor log file exists, if not print error and exit
	{
		printf("\nFailed to read from '%s'. Please check filename.\n\n", InputLogFilename);
		return(3);
	}

	FO = fopen(OutputDatFilename,"w+");    			// Open Output file for output (overwriting previous contents)

	if (!FO)							// Check to see if output dat file has been opened for writing, if not print error and exit
	{
		printf("\nFailed to write to '%s'\n\n", OutputDatFilename);
		return(3);
	}

	//Let's Write the header for the DAT file before we do anything else!
	fprintf (FO, "clrmamepro (\n");										// Header Line 1  followed by a cr
	fprintf (FO, "	name FixGen Missing Files for %s\n", NickName);						// Header Line 2  followed by a cr
	fprintf (FO, "	description \"FixGen Missing Files for %s\"\n", NickName);				// Header Line 3  followed by a cr
	fprintf (FO, "	category \"FixGen\"\n");								// Header Line 4  followed by a cr
	fprintf (FO, "	version 20020505\n");									// Header Line 5  followed by a cr
	fprintf (FO, "	author \"FixGen generated CLRMAME Dat file, http://cheat.retrogames.com/\"\n");		// Header Line 6  followed by a cr
	fprintf (FO, "	version 20020504\n");									// Header Line 7  followed by a cr
	fprintf (FO, "	forcemerging split\n");									// Header Line 8  followed by a cr
	fprintf (FO, ")\n");											// Header Line 9  followed by a cr
	fprintf (FO, "\n");											// Header Line 10  followed by a cr
	fprintf (FO, "game (\n");										// Header Line 11  followed by a cr
	fprintf (FO, "	name %sfix\n",NickName);								// Header Line 12  followed by a cr
	fprintf (FO, "	description \"%sfix\"\n",NickName);							// Header Line 13  followed by a cr
	fprintf (FO, "	manufacturer \"Various\"\n");								// Header Line 14  followed by a cr

	for(;;)								// Main loop body to read through the whole log file
	{

		if (fgets(CLRMAMEDatLine, 256, FI) == NULL)
		break;

		pointer = strtok(CLRMAMEDatLine, ":");			//Get the name of the game (ie characters upto first ':')
		if (pointer==NULL)					//If the line contains no ':' character let's forget about that line
			continue;
		strcpy (CLRMAMEDat.ROMname, pointer);			//Put the ROM name into the array

		if (!strcmp("missing rom", CLRMAMEDat.ROMname))		// Is this log file line a missing rom line or not?
		{							// We are now looking at a missing rom line - in this format:
									// missing rom: nffj.03 [size: 524288] [CRC32: 0x247521ef]
			pointer = strtok(NULL, " ");			// We then read in the filename to the next space - NB: It is not important if the
									// filename contains a space as we are going to make the filename unique with the
									// crc tagged on the end. The files will be rebuilt according to crc by CLRMAME on
									// receipt of the massive (?) fix.zip file anyway. The only important thing is to
									// get unique filenames to stop overwriting.
			strcpy(CLRMAMEDat.ROMname,pointer);      	// We have the ROM Name or at least the part to the first space.
			pointer = strtok(NULL, ":");			// let's move to the ':'
			pointer = strtok(NULL, "]");			// let's move to the ']'
			strcpy(CLRMAMEDat.ROMsize,pointer);		// We have the ROM Size.
			pointer = strtok(NULL, "x");			// let's move to the 'x' of 'CRC32: 0x'
			pointer = strtok(NULL, "]");			// let's move to the ']'
			strcpy(CLRMAMEDat.ROMcrc,pointer);     		// We have the ROM CRC32.
			ROMNumber++;					// Increment the count of the number of ROMs in the dat file by 1
			fprintf (FO, "	rom ( name %s%s size%s crc %s )\n", CLRMAMEDat.ROMname, CLRMAMEDat.ROMcrc, CLRMAMEDat.ROMsize, CLRMAMEDat.ROMcrc);
									// We will print the line out thus (TABBED OF COURSE!):-
									// 	rom ( name ROMnameROMcrc size ROMsize crc ROMcrc )
									// ie:  rom ( name nffj.03247521ef size 524288 crc 247521ef )
			}
	}
	fprintf (FO, ")\n");				// Mustn't forget the close bracket!
	fclose(FI);					// Close the input log file
	fclose(FO);					// Close the output dat file
	printf("\n%d files (ROMS etc) have been added to %s from %s", ROMNumber, OutputDatFilename, InputLogFilename );
	printf("\nJust zip %s up and send it to somebody who knows how to use CLRMAME Pro",  OutputDatFilename);
	return(0);
}
